#ifndef __ERROR_H
#include <stdio.h>
#include <errno.h>
#include <string.h>

#define ERROR_MSG_BUFLEN			65536

#define ERROR_APPEND(format, ...)	error_append(__FILE__, __LINE__, __func__, format, ##__VA_ARGS__)
#define ERROR_APPEND_ERRNO(format, ...)	error_append(__FILE__, __LINE__, __func__, format " errno = %d -> \"%s\"", ##__VA_ARGS__, errno, strerror(errno))
#define ERROR_APPEND_MALLOC()		ERROR_APPEND(error_malloc)
#define MESSAGE_APPEND(format, ...)
#define MESSAGE_PRINT(fd)

void error_append(const char *file, unsigned int line, const char *function, const char *format, ...);
void error_delete(void);
int error_is_pending(void);
void error_print(FILE *out);
void error_lock(void);
void error_unlock(void);

extern const char error_malloc[];

#endif
